NamedDomainObjectCollection (Gradle API 2.10)
Date: 2015-12-21

Package: org.gradle.api

## [Java] Interface NamedDomainObjectCollection<T>

- org.gradle.api.NamedDomainObjectCollection

- All Superinterfaces:
    Iterable, DomainObjectCollection

  A `NamedDomainObjectCollection` represents a collection of domain objects that have an inherent, constant, name.

  Objects to be added to a named domain object collection must implement `equals()` in such a way that no two objects with different names are considered equal. That is, all equality tests must consider the name as an equality key. Behavior is undefined if two objects with different names are considered equal by their `equals()` implementation.

  All implementations must guarantee that all elements in the collection are uniquely named. That is, an attempt to add an object with a name equal to the name of any existing object in the collection will fail. Implementations may choose to simply return false from `add(T)` or to throw an exception.

  Objects in the collection are accessible as read-only properties, using the name of the object as the property name. For example (assuming the 'name' property provides the object name):

       books.add(new Book(name: "gradle", title: null))
       books.gradle.title = "Gradle in Action"

  A dynamic method is added for each object which takes a configuration closure. This is equivalent to calling getByName(String, groovy.lang.Closure). For example:

       books.add(new Book(name: "gradle", title: null))
       books.gradle {
         title = "Gradle in Action"
       }

  You can also use the `[]` operator to access the objects of a collection by name. For example:

       books.add(new Book(name: "gradle", title: null))
       books['gradle'].title = "Gradle in Action"

  Rule objects can be attached to the collection in order to respond to requests for objects by name where no object with name exists in the collection. This mechanism can be used to create objects on demand. For example:

       books.addRule('create any') { books.add(new Book(name: "gradle", title: null)) }
       books.gradle.name == "gradle"

  Parameters:
    `` - The type of domain objects in this collection.

- - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `boolean` | `add(T e)` Adds an object to the collection, if there is no existing object in the collection with the same name.
    `boolean` | `addAll(Collection<? extends T> c)` Adds any of the given objects to the collection that do not have the same name as any existing element.
    `Rule` | `addRule(Rule rule)` Adds a rule to this collection.
    `Rule` | `addRule(String description, groovy.lang.Closure ruleAction)` Adds a rule to this collection.
    `T` | `findByName(String name)` Locates an object by name, returning null if there is no such object.
    `SortedMap<String, T>` | `getAsMap()`
    `T` | `getAt(String name)` Locates an object by name, failing if there is no such task.
    `T` | `getByName(String name)` Locates an object by name, failing if there is no such object.
    `T` | `getByName(String name, groovy.lang.Closure configureClosure)` Locates an object by name, failing if there is no such object.
    `Namer<T>` | `getNamer()` An object that represents the naming strategy used to name objects of this collection.
    `SortedSet<String>` | `getNames()`
    `List<Rule>` | `getRules()` Returns the rules used by this collection.
    `NamedDomainObjectCollection<T>` | `matching(Spec<? super T> spec)` {@inheritDoc}
    `NamedDomainObjectCollection<T>` | `matching(groovy.lang.Closure spec)` {@inheritDoc}
    `NamedDomainObjectCollection<S>` | `withType(Class<S> type)` {@inheritDoc}

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `interface DomainObjectCollection` | `all, all, findAll, matching, matching, whenObjectAdded, whenObjectAdded, whenObjectRemoved, whenObjectRemoved, withType, withType, withType`
    `interface Collection` | `add, equals, hashCode, clear, contains, isEmpty, size, toArray, toArray, addAll, iterator, remove, containsAll, removeAll, retainAll`

- - ### Method Detail

    - #### public boolean add(T e)

      Adds an object to the collection, if there is no existing object in the collection with the same name.

      Parameters:
        `e` - the item to add to the collection
      Returns:
        `true` if the item was added, or {@code} false if an item with the same name already exists.

    - #### public boolean addAll(Collection<? extends T> c)

      Adds any of the given objects to the collection that do not have the same name as any existing element.

      Parameters:
        `c` - the items to add to the collection
      Returns:
        `true` if any item was added, or {@code} false if all items have non unique names within this collection.

    - #### public Rule addRule(Rule rule)

      Adds a rule to this collection. The given rule is invoked when an unknown object is requested by name.

      Parameters:
        `rule` - The rule to add.
      Returns:
        The added rule.

    - #### public Rule addRule(String description, groovy.lang.Closure ruleAction)

      Adds a rule to this collection. The given closure is executed when an unknown object is requested by name. The requested name is passed to the closure as a parameter.

      Parameters:
        `description` - The description of the rule.
        `ruleAction` - The closure to execute to apply the rule.
      Returns:
        The added rule.

    - #### public T findByName(String name)

      Locates an object by name, returning null if there is no such object.

      Parameters:
        `name` - The object name
      Returns:
        The object with the given name, or null if there is no such object in this collection.

    - #### public SortedMap<String, T> getAsMap()

      Returns the objects in this collection, as a map from object name to object instance.

      The map is ordered by the natural ordering of the object names (i.e. keys).

      Returns:
        The objects. Returns an empty map if this collection is empty.

    - #### public T getAt(String name)

      Locates an object by name, failing if there is no such task. This method is identical to getByName(String). You can call this method in your build script by using the groovy `[]` operator.

      throws:
        UnknownDomainObjectException when there is no such object in this collection.
      Parameters:
        `name` - The object name
      Returns:
        The object with the given name. Never returns null.

    - #### public T getByName(String name)

      Locates an object by name, failing if there is no such object.

      throws:
        UnknownDomainObjectException when there is no such object in this collection.
      Parameters:
        `name` - The object name
      Returns:
        The object with the given name. Never returns null.

    - #### public T getByName(String name, groovy.lang.Closure configureClosure)

      Locates an object by name, failing if there is no such object. The given configure closure is executed against the object before it is returned from this method. The object is passed to the closure as its delegate.

      throws:
        UnknownDomainObjectException when there is no such object in this collection.
      Parameters:
        `name` - The object name
        `configureClosure` - The closure to use to configure the object.
      Returns:
        The object with the given name, after the configure closure has been applied to it. Never returns null.

    - #### public Namer<T> getNamer()

      An object that represents the naming strategy used to name objects of this collection.

      Returns:
        Object representing the naming strategy.

    - #### public SortedSet<String> getNames()

      Returns the names of the objects in this collection as a Set of Strings.

      The set of names is in natural ordering.

      Returns:
        The names. Returns an empty set if this collection is empty.

    - #### public List<Rule> getRules()

      Returns the rules used by this collection.

      Returns:
        The rules, in the order they will be applied.

    - #### public NamedDomainObjectCollection<T> matching(Spec<? super T> spec)

      {@inheritDoc}

    - #### public NamedDomainObjectCollection<T> matching(groovy.lang.Closure spec)

      {@inheritDoc}

    - #### public NamedDomainObjectCollection<S> withType(Class<S> type)

      {@inheritDoc}